<template>
    <v-container grid-list-xl >
        <div v-if="!loading">
            <v-layout column justify-center align-center >
                <v-flex>
                    <h1 class="Title"> <span>{{message}}</span> </h1>
                </v-flex><br>
                <v-flex xl12 class="pr-14p">
                    <p> Search : </p>
                    <textarea class="form-add"  type="text" v-model="search" /> <br>
                </v-flex>

            </v-layout>

            <v-layout column>
                <v-flex xl12 class="pr-5p">
                    <ul>
                        <movie-item v-for="(movie, index) in movies_search" v-bind:key="movie.id" v-bind:movie="movie" v-on:edit="edit(movie)" v-on:detail="detail(movie)" v-on:remove="remove(index)"></movie-item>
                    </ul>
                </v-flex>
            </v-layout>
        </div>
        <div v-else>
            chargement....
        </div>
    </v-container>
</template>


<script>
import { db } from '../firebase';

export default {
    
    data() {
        return {
            message: "Hello VueJS",
            movie_to_edit: null,
            
            search: "",
            loading: true,
            movies:[],
        }
    },

    methods: {
        detail:function(movie){
            return this.$router.push({name:'movie',params:{movie : movie.id }})
        },
        edit: function(movie) {
            this.movie_to_edit = movie.id
            return this.$router.push({ name: 'edit', params: { movie : this.movie_to_edit } }) 
        },
        remove: function(index) {
            this.movies.splice(index, 1)
        },
        newmovie:function(){
            return this.$router.push({name:'newmovie'})
        },
        getMovies: async function(){
            const ref = await db.collection("movies");
            var movie = []
            ref.onSnapshot(function(snapchot){
                snapchot.forEach((doc)=>{
                    movie.push({
                        id: doc.id,
                        title: doc.data().title,
                        year: doc.data().year,
                        note: doc.data().note,
                        type: doc.data().type,
                        realisator: doc.data().realisator,
                        synopsys: doc.data().synopsys,
                        display: doc.data().display,
                        img: doc.data().img
                    });
                });
            })
            this.movies = movie;
            this.loading = false;
        }
    
    },

    created: function(){
        this.getMovies();
    },

    computed: {
        firstletter: function() {
            return this.message[0]
        },
        movies_search: function() {
            return this.movies.filter(m => m.title.toLowerCase().indexOf(this.search.toLowerCase())!=-1
                                        || m.synopsys.toLowerCase().indexOf(this.search.toLowerCase())!=-1
                                        || m.year.indexOf(this.search.toLowerCase())!=-1
                                        || m.type.toLowerCase().indexOf(this.search.toLowerCase())!=-1
                                        || m.realisator.firstname.toLowerCase().indexOf(this.search.toLowerCase())!=-1
                                        || m.realisator.lastname.toLowerCase().indexOf(this.search.toLowerCase())!=-1
                                        || m.realisator.birthdate.toLowerCase().indexOf(this.search.toLowerCase())!=-1)
            ;
        }
    }
}

</script>